Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Generator/RegressionBenchmark.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Generator/RegressionBenchmark.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Generator/RegressionBenchmark.cs	(revision 7095)
@@ -52,4 +52,6 @@
     #endregion
 
+    protected static FastRandom rand = new FastRandom();
+
     protected RegressionBenchmark() { }
     protected RegressionBenchmark(RegressionBenchmark original, Cloner cloner)
@@ -67,5 +69,4 @@
     public static List<double> GenerateUniformDistributedValues(int amount, DoubleRange range) {
       List<double> values = new List<double>();
-      System.Random rand = new System.Random();
       for (int i = 0; i < amount; i++) {
         values.Add(rand.NextDouble() * (range.End - range.Start) + range.Start);
@@ -76,5 +77,4 @@
     public static List<double> GenerateNormalDistributedValues(int amount, double mu, double sigma) {
       List<double> values = new List<double>();
-      FastRandom rand = new FastRandom();
       for (int i = 0; i < amount; i++) {
         values.Add(NormalDistributedRandom.NextDouble(rand, mu, sigma));
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionEight.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionEight.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionEight.cs	(revision 7095)
@@ -28,8 +28,8 @@
 
     public KornFunctionEight() {
-      Name = "Korn 8 y = 6.87 + (11 * cos(7.23 * X0 * X3 * X4))";
+      Name = "Korn 8 y = 6.87 + (11 * sqrt(7.23 * X0 * X3 * X4))";
       Description = "Paper: Accuracy in Symbolic Regression" + Environment.NewLine
         + "Authors: Michael F. Korns" + Environment.NewLine
-        + "Function: y = 6.87 + (11 * cos(7.23 * X0 * X3 * X4))" + Environment.NewLine
+        + "Function: y = 6.87 + (11 * sqrt(7.23 * X0 * X3 * X4))" + Environment.NewLine
         + "Real Numbers: 3.45, -.982, 100.389, and all other real constants" + Environment.NewLine
         + "Row Features: x1, x2, x9, and all other features" + Environment.NewLine
@@ -39,7 +39,8 @@
         + "We test each of the test cases on matrices of 10000 rows by 1 to 5 columns with no noise. "
         + "For each test a training matrix is filled with random numbers between -50 and +50. The test case "
-        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
+        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"" + Environment.NewLine + Environment.NewLine
+        + "Note: Because of the square root only non-negatic values are created for the input variables!";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0", "X3", "X4" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -51,7 +52,7 @@
       for (int i = 0; i < data[0].Count; i++) {
         x0 = data[0][i];
-        x3 = data[1][i];
-        x4 = data[2][i];
-        results.Add(6.87 + (11 * Math.Cos(7.23 * x0 * x3 * x4)));
+        x3 = data[3][i];
+        x4 = data[4][i];
+        results.Add(6.87 + (11 * Math.Sqrt(7.23 * x0 * x3 * x4)));
       }
       return results;
@@ -60,5 +61,5 @@
     protected override List<List<double>> GenerateInput() {
       List<List<double>> dataList = new List<List<double>>();
-      DoubleRange range = new DoubleRange(-50, 50);
+      DoubleRange range = new DoubleRange(0, 50);
       for (int i = 0; i < inputVariables.Count; i++) {
         dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionEleven.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionEleven.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionEleven.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFive.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFive.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFive.cs	(revision 7095)
@@ -39,7 +39,8 @@
         + "We test each of the test cases on matrices of 10000 rows by 1 to 5 columns with no noise. "
         + "For each test a training matrix is filled with random numbers between -50 and +50. The test case "
-        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
+        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"" + Environment.NewLine + Environment.NewLine
+        + "Note: Because of the logarithm only non-negatic values are created for the input variables!";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X4" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -50,5 +51,5 @@
       List<double> results = new List<double>();
       for (int i = 0; i < data[0].Count; i++) {
-        x4 = data[0][i];
+        x4 = data[4][i];
         results.Add(3.0 + (2.13 * Math.Log(x4)));
       }
@@ -58,5 +59,5 @@
     protected override List<List<double>> GenerateInput() {
       List<List<double>> dataList = new List<List<double>>();
-      DoubleRange range = new DoubleRange(-50, 50);
+      DoubleRange range = new DoubleRange(0, 50);
       for (int i = 0; i < inputVariables.Count; i++) {
         dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFiveteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFiveteen.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFiveteen.cs	(revision 7095)
@@ -39,7 +39,8 @@
         + "We test each of the test cases on matrices of 10000 rows by 1 to 5 columns with no noise. "
         + "For each test a training matrix is filled with random numbers between -50 and +50. The test case "
-        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
+        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"" + Environment.NewLine + Environment.NewLine
+        + "Note: Because of the logarithm only non-negatic values are created for the input variables!";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0", "X1", "X2", "X3" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -61,5 +62,5 @@
     protected override List<List<double>> GenerateInput() {
       List<List<double>> dataList = new List<List<double>>();
-      DoubleRange range = new DoubleRange(-50, 50);
+      DoubleRange range = new DoubleRange(0, 50);
       for (int i = 0; i < inputVariables.Count; i++) {
         dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFour.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFour.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFour.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X2" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -50,5 +50,5 @@
       List<double> results = new List<double>();
       for (int i = 0; i < data[0].Count; i++) {
-        x2 = data[0][i];
+        x2 = data[2][i];
         results.Add(-2.3 + (0.13 * Math.Sin(x2)));
       }
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFourteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFourteen.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionFourteen.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0", "X1", "X2", "X3" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionNine.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionNine.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionNine.cs	(revision 7095)
@@ -39,7 +39,8 @@
         + "We test each of the test cases on matrices of 10000 rows by 1 to 5 columns with no noise. "
         + "For each test a training matrix is filled with random numbers between -50 and +50. The test case "
-        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
+        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"" + Environment.NewLine + Environment.NewLine
+        + "Note: Because of the square root and the logarithm only non-negatic values are created for the input variables!";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0", "X1", "X2", "X3" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -61,5 +62,5 @@
     protected override List<List<double>> GenerateInput() {
       List<List<double>> dataList = new List<List<double>>();
-      DoubleRange range = new DoubleRange(-50, 50);
+      DoubleRange range = new DoubleRange(0, 50);
       for (int i = 0; i < inputVariables.Count; i++) {
         dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionOne.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionOne.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionOne.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X3" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -50,5 +50,5 @@
       List<double> results = new List<double>();
       for (int i = 0; i < data[0].Count; i++) {
-        x3 = data[0][i];
+        x3 = data[3][i];
         results.Add(1.57 + (24.3 * x3));
       }
@@ -59,5 +59,7 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(-50, 50);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      for (int i = 0; i < inputVariables.Count; i++) {
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      }
 
       return dataList;
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionSeven.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionSeven.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionSeven.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionSix.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionSix.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionSix.cs	(revision 7095)
@@ -39,7 +39,8 @@
         + "We test each of the test cases on matrices of 10000 rows by 1 to 5 columns with no noise. "
         + "For each test a training matrix is filled with random numbers between -50 and +50. The test case "
-        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
+        + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"" + Environment.NewLine + Environment.NewLine
+        + "Note: Because of the square root only non-negatic values are created for the input variables!";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -58,5 +59,5 @@
     protected override List<List<double>> GenerateInput() {
       List<List<double>> dataList = new List<List<double>>();
-      DoubleRange range = new DoubleRange(-50, 50);
+      DoubleRange range = new DoubleRange(0, 50);
       for (int i = 0; i < inputVariables.Count; i++) {
         dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTen.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTen.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X1", "X2", "X3", "X4" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -50,8 +50,8 @@
       List<double> results = new List<double>();
       for (int i = 0; i < data[0].Count; i++) {
-        x1 = data[0][i];
-        x2 = data[1][i];
-        x3 = data[2][i];
-        x4 = data[3][i];
+        x1 = data[1][i];
+        x2 = data[2][i];
+        x3 = data[3][i];
+        x4 = data[4][i];
         results.Add(0.81 + (24.3 * (((2.0 * x1) + (3.0 * Math.Pow(x2, 2))) / ((4.0 * Math.Pow(x3, 3)) + (5.0 * Math.Pow(x4, 4))))));
       }
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionThirteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionThirteen.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionThirteen.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0", "X1", "X2", "X3" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionThree.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionThree.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionThree.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0", "X1", "X3", "X4" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -52,6 +52,6 @@
         x0 = data[0][i];
         x1 = data[1][i];
-        x3 = data[2][i];
-        x4 = data[3][i];
+        x3 = data[3][i];
+        x4 = data[4][i];
         results.Add(-5.41 + (4.9 * (((x3 - x0) + (x1 / x4)) / (3 * x4))));
       }
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTwelve.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTwelve.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTwelve.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X0", "X4" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -51,5 +51,5 @@
       for (int i = 0; i < data[0].Count; i++) {
         x0 = data[0][i];
-        x4 = data[0][i];
+        x4 = data[4][i];
         results.Add(2.0 - (2.1 * (Math.Cos(9.8 * x0) * Math.Sin(1.3 * x4))));
       }
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTwo.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTwo.cs	(revision 7094)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Korns/KornFunctionTwo.cs	(revision 7095)
@@ -41,5 +41,5 @@
         + "target expressions are limited to one basis function whose maximum depth is three grammar nodes.\"";
       targetVariable = "Y";
-      inputVariables = new List<string>() { "X1", "X3", "X4" };
+      inputVariables = new List<string>() { "X0", "X1", "X2", "X3", "X4" };
       trainingPartition = new IntRange(0, 5000);
       testPartition = new IntRange(5001, 10000);
@@ -50,7 +50,7 @@
       List<double> results = new List<double>();
       for (int i = 0; i < data[0].Count; i++) {
-        x1 = data[0][i];
-        x3 = data[1][i];
-        x4 = data[2][i];
+        x1 = data[1][i];
+        x3 = data[3][i];
+        x4 = data[4][i];
         results.Add(0.23 + (14.2 * ((x3 + x1) / (3.0 * x4))));
       }
@@ -64,5 +64,4 @@
         dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
       }
-
       return dataList;
     }